\documentclass[a4paper]{tufte-book}

\usepackage{caption}
\usepackage{listings}

\definecolor{mygreen}{rgb}{0,0.6,0}
\definecolor{mygray}{rgb}{0.5,0.5,0.5}
\definecolor{mymauve}{rgb}{0.58,0,0.82}
\definecolor{myred}{rgb}{0.58,0,0}

\lstset{ %
  backgroundcolor=\color{white},   % choose the background color; you must add \usepackage{color} or \usepackage{xcolor}
  basicstyle=\footnotesize\tt,        % the size of the fonts that are used for the code
  breakatwhitespace=false,         % sets if automatic breaks should only happen at whitespace
%  breaklines=true,                 % sets automatic line breaking
  captionpos=b,                    % sets the caption-position to bottom
  commentstyle=\color{mygreen},    % comment style
  deletekeywords={loop,prog,position,string,apropos},     % if you want to delete keywords from the given language
  escapeinside={;;*}{*;;},          % if you want to add LaTeX within your code
  extendedchars=true,              % lets you use non-ASCII characters; for 8-bits encodings only, does not work with UTF-8
%  frame=single,                    % adds a frame around the code
  keywordstyle=\color{myred},       % keyword style
  language=Lisp,                 % the language of the code
  morekeywords={lambda,add1, current-input-port, current-output-port,sub1, define, define-record, equal?, if, when, unless, fprintf, printf, print, display, newline, zero?, null?, inc!, dec!, use},
            % if you want to add more keywords to the set
  numbers=left,                    % where to put the line-numbers; possible values are (none, left, right)
  numbersep=5pt,                   % how far the line-numbers are from the code
  numberstyle=\tiny\color{black}, % the style that is used for the line-numbers
  rulecolor=\color{black},         % if not set, the frame-color may be changed on line-breaks within not-black text (e.g. comments (green here))
  showspaces=false,                % show spaces everywhere adding particular underscores; it overrides 'showstringspaces'
  showstringspaces=false,          % underline spaces within strings only
  showtabs=false,                  % show tabs within strings adding particular underscores
  stepnumber=2,                    % the step between two line-numbers. If it's 1, each line will be numbered
  stringstyle=\color{mymauve},     % string literal style
  tabsize=2,                       % sets default tabsize to 2 spaces
  title=\lstname                   % show the filename of files included with \lstinputlisting; also try caption instead of title
}

\hypersetup{colorlinks}

\title{CHICKEN Scheme\\ {\small A humble tour with real world code}}
%subtitle{A little tour through code that solves real problems.}
\author[Christian Kellermann]{Christian Kellermann}
\publisher{Henrietta Publishing}
\usepackage{booktabs}
\usepackage{graphicx}
\setkeys{Gin}{width=\linewidth,totalheight=\textheight,keepaspectratio}
\graphicspath{{graphics/}}
\usepackage{fancyvrb}
\fvset{fontsize=\normalsize}

\usepackage{xspace}
\newcommand{\monthyear}{%
  \ifcase\month\or January\or February\or March\or April\or May\or June\or
  July\or August\or September\or October\or November\or
  December\fi\space\number\year
}


% Prints an epigraph and speaker in sans serif, all-caps type.
\newcommand{\openepigraph}[2]{%
  %\sffamily\fontsize{14}{16}\selectfont
  \begin{fullwidth}
  \sffamily\large
  \begin{doublespace}
  \noindent\allcaps{#1}\\% epigraph
  \noindent\allcaps{#2}% author
  \end{doublespace}
  \end{fullwidth}
}

% Inserts a blank page
\newcommand{\blankpage}{\newpage\hbox{}\thispagestyle{empty}\newpage}

\usepackage{units}

% Typesets the font size, leading, and measure in the form of 10/12x26 pc.
\newcommand{\measure}[3]{#1/#2$\times$\unit[#3]{pc}}
\usepackage{makeidx}
\makeindex

\begin{document}

% Front matter
%\frontmatter

% r.1 blank page
%\blankpage

% r.3 full title page
\maketitle


% v.4 copyright page
\newpage
\begin{fullwidth}
~\vfill
\thispagestyle{empty}
\setlength{\parindent}{0pt}
\setlength{\parskip}{\baselineskip}
Copyright \copyright\ \the\year\ \thanklessauthor

\par\smallcaps{Published by \thanklesspublisher}

\par This work is licensed under the Creative Commons
Attribution-ShareAlike 3.0 Unported License. To view a copy of this
license, visit \url{http://creativecommons.org/licenses/by-sa/3.0/}.
\index{license}

\par\textit{First printing, \monthyear}
\end{fullwidth}

% r.5 contents
\tableofcontents

%\listoffigures

%\listoftables
\lstlistoflistings

% r.7 dedication
\cleardoublepage
~\vfill
\begin{doublespace}
\noindent\fontsize{18}{22}\selectfont\itshape
\nohyphenation
Dedicated to all the programmers, hackers and tinkerers of this world. May your thirst for knowledge never cease.
\end{doublespace}
\vfill
\vfill


\chapter*{Foreword by the author}

\newthought{Welcome dear} reader to the humble introduction to CHICKEN
Scheme! Let me introduce myself so you know what you are getting into:
My name is Christian Kellermann, I am a programmer for a living and I
have been writing all my programs at home in CHICKEN Scheme. Yes, all
of them!  And it has been a fun ride for most of the time.

\newthought{When I} started out learning programming decades (well, two) ago my
local library carried loads of books filled with little programs one
could type in to get an accounting program, an ``editor'' and of
course lots of games.

\newthought{Back at} the time I did not know how most of the code
worked at the beginning and you could see the little version of me
typing gibberish into the computer. But after reading more code and
books about the Programming languages used (BASIC and Pascal mostly),
I began to recognise something: I began to get used to the tone of a
language, the way the programmers think and write about the
problem. This experience helped me a lot later on, when learning a
language had to become ``a matter of a weekend'' \sidenote{The
  academic weekend does not imply that you are done by Sunday
  afternoon on a regular weekend, but that you have 72 hours straight,
  and if you are a genius you will know it by then.} Whenever I need
to learn a new programming language I want to know the tone of the
language first.

\newthought{And this} is done by reading source code. A lot. And
again. Now usually for a beginner or an advanced programmer learning a
new language this is a huge problem. Is there a large code base to
study?  Which programs are good to read? The examples in most
introductory books are too simple and the problem domain has been
stripped down carefully by authors to make a certain point, while
``real world'' applications tend to get huge monstrosities of thousand
lines of code, mostly grown over the years.

\newthought{So I want} to fill this niche with small yet practical
(and working!)  programs for you to read, use and enjoy to get a real
feeling for my favorite language CHICKEN Scheme. I don't claim that
they are the most beautiful prose ever written, nor that they offer a
clever solution to a special problem (I would be glad to say so!).

\newthought{The examples} discussed in this booklet are little
programs which I wrote for myself to solve real problems I have had to
solve. Some of them made it to my blog
\sidenote{\url{http://pestilenz.org/~ckeen/blog/}} and some have been
revised and extended for this edition.

\newthought{If you} do find any bugs in them or have something to say, please
contact me \sidenote{\url{ckeen@pestilenz.org}} I hope that the following
chapters will help you in getting started with CHICKEN Scheme and that
it will be a joyful experience!

\par{\itshape Nuremberg, February 2013}

\par{\itshape Christian Kellermann}


\mainmatter

\chapter{Introduction}
\label{ch:introduction}

\newthought{This book} is aimed at interested humans that want to know
what it's like to program in CHICKEN Scheme (or chicken for short). A
lot of this also applies to other scheme dialects of course I do know
chicken best and have been using it almost exclusively for the last
years.

\newthought{Each chapter} in this book will guide you through the
source of a program showing you different aspects of CHICKEN and a
different (and hopefully) fun problem to solve.

Chapter 2 will guide you through the setup of your CHICKEN
environment. I will cover GNU/Linux, Mac OS X and Windows and I will
also tell the users of other operating systems where to find further
help here.

In chapter 3 you will write the first Program! I will explain how you
``run'' it, explains the available tools that come with CHICKEN and
warn you against some common pitfalls.

In chapter 4 I will write a little game of sokoban, since all things
start with playing games

In chapter 5 you will see how CHICKEN can be used to implement a small
chat client for the IRC network.

In chapter 6 I show a small program to search a pile of images for a
certain file using a so called ``binding'' to a C library (libexif).

In chapter 7 ...

\chapter{Getting and Installing CHICKEN}
\label{ch:getting}

Let's get the CHICKEN program first. You operating system's package
managers (if you happen to run a GNU/Linux operating system) might
have packaged it for you already. But these packages are probably a
couple of releases behind, which may mean {\em years}. Therefore and
because the other operating systems do not come with CHICKEN usually,
I will show you how you can install CHICKEN from source.

First, grab the CHICKEN source code from the website
\url{http://code.call-cc.org}. But which one should you choose?

As I write this the current chicken version is {\em 4.8.0.2}. The
first three numbers mark major releases, the ``0'' being the indicator for
a stable release. When you see a version number like ``4.8.2'' then
you should know that this is the second development snapshot after the
``4.8.0'' stable release.

The trailing ``.1'' indicates that this is the first {\em stability}
release containing bugfixes that enhance the stability and security of
the CHICKEN system. If there has been a newer version released than
the one above feel free to use the latest stable version or the latest
stability release.

The source code is available as a so called ``tarball'', which is a
particular archive format common for unix systems. If you happen to
run one of these your system will come with the ``tar'' command that
will allow you to extract the contents. If you happen to be running
Windows then additional software needs to be installed.

For unix like systems you will need a build program called GNU make
and the GNU C compiler (``gcc''). For Windows you should download
cygwin, a unix environment, that brings the necessary programs with
it.

So let's assume you have downloaded the chicken source code
({\tt chicken-4.8.0.2.tar.gz}) with your web browser and you have
opened a terminal in that directory.

Unpack the CHICKEN source and build it:

\begin{verbatim}
$ tar xfz chicken-4.8.0.2.tar.gz
$ cd chicken-4.8.0.2
$ make PLATFROM=linux # change to osx or cygwin here
$ make PLATFORM=linux install
\end{verbatim}

If all went well you will have a new CHICKEN installed! Note that the
{\tt make install} step will require root privileges. It is also
possible to install chicken locally only. For this you need to pass an
additional variable to the make steps: {\tt PREFIX}:

\begin{verbatim}
$ cd chicken-4.8.0.2
$ make PLATFROM=linux PREFIX=~/chickens/4.8.0.2
$ make PLATFORM=linux PREFIX=~/chickens/4.8.0.2 install
\end{verbatim}

This will put your CHICKEN files under a {\tt chickens/4.8.0.2}
directory in your home. To be able to use this you will need to
include the path to the binaries in your {\tt PATH} variable:

\begin{verbatim}
$ export PATH=~/chickens/4.8.0.2/bin:$PATH
\end{verbatim}

You can verify whether you got it right:
\begin{verbatim}
$ which csi
/home/ckeen/chickens/4.8.0.2/bin
\end{verbatim}

If this shows your path or {\tt /usr/local/bin/csi}, the local or the
system wide installation is being used. Congratulations! You are now
ready to use the CHICKEN programs!

I assume you have installed CHICKEN locally now, let's see what has
been installed in that {\tt chickens/4.8.0.2} directory now. I will
list the directories and roughly explain what to expect in there.

\bigskip
\begin{minipage}{\textwidth}
\begin{center}
%\footnotesize
\begin{tabular}{lp{10cm}}
\toprule
Directory & Description\\
\midrule
bin & 
Holds all the binaries, the interpreter, the compiler and the
extension management programs.\\
include/chicken &
Holds include files necessary for embedding CHICKEN into your C(++) Programs.\\
lib/chicken/6 &
Holds all extensions and so called ``core units'' that you can load
into your code to enable functionality not present at the startup of
your chicken program.\\
share/chicken/doc/manual &
Holds the CHICKEN manual in HTML format for you to explore. Point your
web browser at the {\tt index.html} file to get started.\\
man/man1 &
Holds the manual pages for the programs in {\tt bin}. You will have
to include this path to your {\tt MANPATH} to be included into your
system's {\tt man(1)} program.\\
\bottomrule
\end{tabular}
\end{center}
\end{minipage}
\bigskip

In the {\tt bin} directory you will find all the useful tools that
come with CHICKEN: The chicken compiler ({\em chicken}), the chicken
interpreter {\tt csi}, the chicken compiler driver {\tt csc} and the
extension manager trio: {\tt chicken-install},
{\tt chicken-uninstall} and {\tt chicken-status}. Less commonly used
is the profiler ({\tt chicken-profile}) and the bug report helper
{\tt chicken-bug}.

If you ever get tired of CHICKEN you can safely delete the
{\tt chickens} folder. This will leave your system without any
chicken runtime and installed extensions, so your written programs
will not work anymore!

\chapter{CSI - The Interpreter}

CHICKEN is first of all a compiler but most of the users will
encounter the interpreter first. It is called {\tt csi} and will greet
you with a banner stating its name and version, your platform and
enabled system features. So this is CHICKEN waiting for your
input. Let's try some!

\begin{verbatim}
CHICKEN
(c) 2008-2013, The Chicken Team
(c) 2000-2007, Felix L. Winkelmann
Version 4.8.0.2 (stability/4.8.0) (rev 54c391c)
openbsd-unix-gnu-x86 [ manyargs dload ptables ]
compiled 2013-01-17 on aeryn.xorinia.dim (Darwin)

#;1> 42
42
#;2> 23
23
#;3> (+ 1 2)
3
#;4> (* (+ 1 2) 3)
9
\end{verbatim}

\newthought{So you} see numbers are evaluated to themselves, and we can do
arithmetic albeit in a funny notation called ``prefix-notation'',
i.e. the operator comes first. Besides looking funny this has one
advantage: You can add an (almost) arbitrary number of arguments!  So
{\tt (+ 1 2 3 4 5)} will work just as expected! So what's this
{\tt +}? Let's find out!

\begin{verbatim}
#;5> +
#<procedure C_plus>
#;6>
\end{verbatim}

Ah so {\tt +} is a procedure! A procedure taking arguments and
returning the sum of it's arguments.
\marginnote{ What if we give {\tt +} no argument?}
\begin{verbatim}
#;6> (+)
0
\end{verbatim}
\marginnote{What if we try to add something that is not a number?}
\begin{verbatim}
#;7> (+ 1 "hello")
Error: (+) bad argument type: "hello"

        Call history:

        <syntax>          (+ 1 "hello")
        <eval>    (+ 1 "hello")   <--
#;8>
\end{verbatim}

The last example shows us an error message from the interpreter. This
is a typical error condition that has not been handled
specially. CHICKEN will always greet you with the stoic ``Error:'' in
this case followed by the procedure causing the error and a more or
less descriptive error message. In this case it tells us that
``hello'' is not the argument type {\tt +} expected. We are on our
own to conclude that we wanted to add numbers and that ``hello''
probably is a bad example for a number.

Now sometimes the exception contains further useful information you
can use to debug your programs, let's tell {\tt csi} to display it. To do so we issue a special command in the REPL: {\tt ,exn}.
\begin{verbatim}
#;8> ,exn
condition: (exn type)
 exn
        message: "bad argument type"
        arguments: ("foo")
        call-chain: (#("<syntax>" (+ 1 "foo") #f) #("<eval>" (+ 1 "foo") #<frameinfo>))
        location: +
 type
#;9>
\end{verbatim}

\newthought{There are} even more special commands. One of the most important ones
is {\tt ,q} which will quit the interpreter. You get the whole list
with {\tt ,?}. Another useful command is {\tt ,d} which will print
CHICKEN's idea of a thing we enter into the REPL. So for your
procedure {\tt +} we get:
\begin{verbatim}
#;9> ,d +
         procedure with code pointer 0x4bacfa0 of length 1
 0: #<lambda info C_plus>
\end{verbatim}

Which tells us that {\tt +} really is a procedure, called a
``lambda'' traditionally and in this case that it is a special type of
procedure. (Procedures with ``C\_'' prefixes indicate that this
procedure is actually implemented in C and not in scheme. This has
been done for speed reasons.) So with prefix notation and the
arithmetic procedures we can use our REPL as a calculator. And as with
any decent calculator you can reuse intermediate results. So if we start with a new {\tt csi} and let it do some calculations for us:
\begin{verbatim}
#;1> (+ 2 3)
5
#;2> (* 12 34)
408
#;3> (- 45 3)
42
#;4> (/ 2 12) 
0.166666666666667
#;5> (* 3 (/ 65 7))
27.8571428571429
\end{verbatim}
\newthought{You can} reuse the results returned for one line of expressions by
referring to the number written in the prompt prefixed by the hash
character {\tt \#}.
\begin{verbatim}
#;6> (+ #1 #2 #3)
455
#;7> #4
0.166666666666667
\end{verbatim}
This will come in very handy when you are exploring programs and
problems in the interpreter and want to reuse results you have already
calculated in earlier steps. If you want to erase all the history (and
free the objects, so they can get ``cleaned up'') you can use the
special top-level command {\tt ,ch} (short for ``clear history'').

\newthought{Maybe you} have already noticed that {\tt csi} does not
support a comfortable line editing mode by default. Which means that
whenever you try to move the cursor with the arrow keys you will see
funny characters like {\tt ``\^{}[[D''}. To enable a more comfortable line
editor install the {\it parley} (and {\it apropos}) extension via {\tt
  chicken-install}: {\tt chicken-install apropos parley}. Then you
need to enable it by default whenever you start csi. To do so create a
file called {\tt .csirc} \marginnote{You can put any scheme expression
  inside this file. {\tt csi} will execute it every time you start
  it. To avoid this behavior start csi with the {\tt -n} switch.}
(note the leading dot) and add the following lines to it:

\begin{lstlisting}[caption={\tt .csirc} with tab completion]
(use apropos parley parley-auto-completion)

(let ((old (current-input-port)))
     (current-input-port (make-parley-port old)))

(completion-choices
 (lambda (input position last-word)
   (map symbol->string (apropos-list last-word))))

(word-class '(: (? (* any) whitespace) ($ (+ (~ "()[]")))))

(add-key-binding! #\tab auto-completion-handler)
\end{lstlisting} %$ quiet syntax highlighting

After that you will notice that now you can use your cursor keys, have
a command history within one session you can browse with the up and
down keys and you will have tab completion for procedures {\tt csi}
knows about (through the apropos extension). To test this, start a new
csi and type the character ``{\tt l}'', then hit tab. You will see a
list of procedures starting with that letter. Now type ``{\tt i}'' and
hit tab again: The word should have been expanded to ``list''. You can
use this whenever you need to complete a procedure name. This way even
{\tt call-with-current-continuation} will become a short name!

\chapter{Interpreting an interpreter: brainfuck}
\label{ch:brainfuck}

\newthought{For our first} program we will build also a small
interpreter of a turing complete programming language: brainfuck.
\marginnote{Whenever someone says ``turing complete'', she means that
  you could express every program you can think of within that
  language {\em in principle}. This however makes no assumption about
  convenience or easy of reading.}  The brainfuck language interpreter
will read in a brainfuck program on standard input first. Setting up
its virtual machine state and start processing the program until the
last instruction has been executed.

\newthought{The virtual machine} consists of a memory region for
storing data in cells holding values from 0 to 255, the ``index
pointer'' pointing to one of these cells which is considered the
current cell, a memory region holding our program instructions and an
instruction pointer pointing to the current instruction.

\newthought{The brainfuck dialect} used in this chapter uses the
characters shown in the table as instructions and will step over
any other character found in the output.

\bigskip
\begin{minipage}{\textwidth}
\begin{center}
\begin{tabular}{cl}
\toprule
Command & Meaning\\
\midrule
{\tt >} & Increase the data stored in this cell by one\\
{\tt <} & Decrease the data stored in this cell by one\\
{\tt +} & Advance the cell pointer to  the next cell\\
{\tt -} & Move the cell pointer one cell back\\
{\tt .} & Print the value in the current cell as character\\
{\tt ,} & Read in a character (from standard input) and store it in the current cell\\
{\tt [} & If the current cell is 0 jump to the instruction behind the matching {\tt ]}\\
{\tt ]} & If the current cell is not zero jump back to the matching {\tt [}\\
{\tt \#} & Print the current state of the VM (used for debugging purposes)\\
\bottomrule
\end{tabular}
\end{center}
\end{minipage}

\newthought{Before looking at} the scheme code, let's see what a
typical brainfuck program looks like. This little program will output
the familiar ``Hello World!'' string when interpreted.

\begin{verbatim}
++++++++++[>+++++++>++++++++++>+++>+<<<<-]>++.>+.+++++++
..+++.>++.<<+++++++++++++++.>.+++.------.-------- .>+.>.
\end{verbatim}

\newthought{Now you might get} an idea where the name of this language
originates from. Let's add some comments to the code. As you know
every character not part of the language will be ignored.

\begin{verbatim}
+++++ +++++             initialize counter (cell 0) to 10
[                       use loop to set the next four cells to 70/100/30/10
    > +++++ ++          add  7 to cell 1
    > +++++ +++++       add 10 to cell 2 
    > +++               add  3 to cell 3
    > +                 add  1 to cell 4
    <<<< -              decrement counter (cell 0)
]
> ++ .                  print 'H'
> + .                   print 'e'
+++++ ++ .              print 'l'
.                       print 'l'
+++ .                   print 'o'
> ++ .                  print ' '
<< +++++ +++++ +++++ .  print 'W'
> .                     print 'o'
+++ .                   print 'r'
----- - .               print 'l'
----- --- .             print 'd'
> + .                   print '!'
> .                     print '\n'
\end{verbatim}

\newthought{With brainfuck} even simple problems surely get
complicated! Luckily CHICKEN Scheme makes deciphering this code easy.
Let's have a look at our interpreter code.

%\lstinputlisting[caption=The brainfuck interpreter]{code/brainfuck.scm}
\begin{lstlisting}[caption=The brainfuck interpreter]
(use miscmacros extras (srfi 1 4 13)) ;;*\marginnote{You will need to install the {\tt miscmacros} extension by running ``chicken-install miscmacros'' on the command line of your shell. Also note the shortcut for specifying SRFIs. This can be used instead of repeating {\tt srfi-1}, {\tt srfi-4}, etc.}*;;

(define-record vm
  (setter idx)
  (setter pc)
  (setter program)
  (setter paren-stack)
  (setter tape))

(define-record-printer (vm v p) ;;*\marginnote{This is a non-standard form to define a printer for a record type. Whenever our {\tt vm}-type has to be printed, this procedure will get called instead.}*;;
    (fprintf p
           "#,<vm pc ~s data ~s (~s) stack ~s>"
           (vm-pc v)
           (vm-idx v)
           (u8vector-ref (vm-tape v) (vm-idx v))
           (vm-paren-stack v)))

(define mem-size (make-parameter 30000))
(define debug? (make-parameter #f)) ;;*\marginnote{Parameters are scheme's way of introducing dynamically scoped variables. This will come in handy when you want to tweak values that should effect compiled code.}*;;

(define (init-machine!)
  (make-vm 0 0 "" '() #f))

(define (load-from-file file)
  (let ((code
         (string-concatenate
          (with-input-from-file file read-lines)))
        (vm (init-machine!)))
    (set! (vm-tape vm) (make-u8vector (mem-size) 0))
    (set! (vm-program vm) code) ;;*\marginnote{Here you can see an example of the generalized setter we have declared with the {\tt setter} slot prefix of the {\tt define-record} above.}*;;
    vm))

(define (find-loop-start pc prog)
  (let loop ((p pc)
             (open-parens 0))
    (cond ((< open-parens 0)
           (error "One [ too many in " (sub1 p)))
          ((< p 0)
           (error "] without matching ["))
          ((equal? (string-ref prog p)
                   #\])
           (loop (sub1 p)
                 (add1 open-parens)))
          ((equal? (string-ref prog p)
                    #\[)
           (if (= 0 (sub1 open-parens))
               p
               (loop (sub1 p)
                     (sub1 open-parens))))
          (else (loop (sub1 p) open-parens)))))
;;*\marginnote{The {\tt find-loop-} procedures are little optimisation helpers for us to keep track of the matching brackets. The index for the program counter is stored in the list paren-stack.}*;;
(define (find-loop-end pc prog)
  (let loop ((p pc)
             (open-parens 0))
    (cond ((< open-parens 0)
           (error "One ] too many in " (sub1 p)))
          ((> p (sub1 (string-length prog)))
           (error "Unexpected end of file"))
          ((equal? (string-ref prog p)
                   #\[)
           (loop (add1 p)
                 (add1 open-parens)))
          ((equal? (string-ref prog p)
                    #\])
           (if (= 0 (sub1 open-parens))
               p
               (loop (add1 p)
                     (sub1 open-parens))))
          (else (loop (add1 p) open-parens)))))
;;*\marginnote{Here starts the implementation of the brainfuck commands shown in the table at the beginning of this chapter. Each of these procedures creates a {\tt vm} record holding the {\em next} interpreter state.}*;;
(define (move-right vm)
  (let ((new vm))
    (inc! (vm-idx new))
    new))

(define (move-left vm)
  (let ((new vm))
    (dec! (vm-idx new))
    new))
;;*\marginnote{This is a pretty common pattern found in scheme code. Whenever you find yourself writing the same statements again with just a minor difference in them, it's a sign that factoring out the commonalities may be a good strategy. In this case we want to change the current cell but the change is either {\tt add1} or {\tt sub1}. So we pass that to the helper function. I think this is more readable, how about you?}*;;
(define (change-curr-cell vm prod)
  (let* ((new vm)
         (curr (u8vector-ref (vm-tape new) (vm-idx new))))
    (u8vector-set! (vm-tape new) (vm-idx new) (modulo (prod curr) 256))
    new))

(define (inc-curr-cell vm) (change-curr-cell vm add1))
(define (dec-curr-cell vm) (change-curr-cell vm sub1))

(define (print-curr-cell vm)
  (display (integer->char (u8vector-ref (vm-tape vm) (vm-idx vm))))
  (flush-output)
  vm)

(define (read-char-in vm)
  (let* ((new vm)
         (c (read-char)))
    (unless (eof-object? c)
            (u8vector-set! (vm-tape new) (vm-idx new) (char->integer c)))
    new))

(define (handle-loop-start vm)
  (let ((new vm))
    (push! (vm-pc new) (vm-paren-stack new))
    (when (zero? (u8vector-ref (vm-tape new) (vm-idx new)))
          (set! (vm-pc new) (sub1 (find-loop-end (vm-pc new) (vm-program new)))))
    new))

(define (handle-loop-end vm)
  (let ((new vm))
    (if (not (zero? (u8vector-ref (vm-tape new) (vm-idx new))))
        (set! (vm-pc new) (car (vm-paren-stack new)))
        (pop! (vm-paren-stack new)))
    new))

(define (print-vm-state vm) ;;*\marginnote{Here we use our record printer from above to generate debugging output. In order to stay clear of the program generated output, we print the VM state to the {\tt (current-error-port)}.}*;;
  (when (debug?)
        (display vm (current-error-port))
        (newline (current-error-port)))
  vm)

(define (bf-eval m) ;;*\marginnote{Finally we get to the core interpreter loop! This will take an initial VM state, fetch the command from the program counter position, advance the program counter and calls itself again if the program counter is still within the source of the program, i.e. we still have some commands left. Note that the identity procedure is used for characters in the program source that are not part of the language. One can imagine an optimization when you read in the source to already strip these characters from the input. This will save some interpreter cycles.}*;;
  (let ((action
         (case (string-ref (vm-program m) (vm-pc m))
           ((#\>) move-right)
           ((#\<) move-left)
           ((#\+) inc-curr-cell)
           ((#\-) dec-curr-cell)
           ((#\.) print-curr-cell)
           ((#\,) read-char-in)
           ((#\[) handle-loop-start)
           ((#\]) handle-loop-end)
           ((#\#) print-vm-state)
           (else identity)))
        (next-pc (add1 (vm-pc m))))
    (when (< next-pc
           (string-length (vm-program m)))
          (set! (vm-pc m) next-pc)
          (bf-eval (action m)))))
\end{lstlisting}

\newthought{Save this} file as ``bf.scm'' and open up a {\tt csi}
session. Then load the file with either {\tt (load ``bf.scm'')} or the
{\tt ,l} toplevel command: {\tt ,l bf.scm}.

\newthought{If you have been} enduring enough to type in the hello
world example from above you can now execute it by calling the {\tt
  bf-eval} procedure with a loaded file: (bf-eval (load-from-file
``hello.bf'')). \marginnote{This assumes also that you have saved it
  as a file called ``hello.bf''. Now if you do not want to type in the
  whole thing you can download it from
  \url{http://pestilenz.org/~ckeen/humble/code/hello.bf}}

\begin{verbatim}
#;1> ,l bf.scm
#;2> (bf-eval (load-from-file "hello.bf"))
Hello World!
#;3>
\end{verbatim}

\newthought{If you have} made a mistake while typing in the program
that is not directly a syntax error, you might want to debug it. Most
CHICKEN Scheme users resort to printf debugging, where one inserts
{\tt (print)} statements throughout the code to extract runtime
information. This is actually quite useful to narrow down the region
where your error occurs.

\newthought{For example} if you'd like to know the parameters a
procedure gets called with you will open up the file, put display or
print statements in it, save the file, reload it in the interpreter
and run it. If you are hunting a bug through a larger project this
will get rather tedious. Also once you have found the bug you will
need to remove all these statements again.

\newthought{Luckily for interpreted} code there is a more general
solution to this: The {\tt trace} extension.\marginnote{This also is
  not installed by default. Run ``chicken-install trace'' to get it.}
With the trace extension you can easily add so called ``tracepoints''
that will print this information for you.

\begin{verbatim}
#;1> ,l brainfuck.scm
; loading brainfuck.scm ...
; loading /home/ckellerm/chickens/master/lib/chicken/7/miscmacros.so ...
; loading /home/ckellerm/chickens/master/lib/chicken/7/srfi-4.import.so ...
; loading library srfi-4 ...
#;1> (use trace)
; loading /home/ckellerm/chickens/master/lib/chicken/7/trace.import.so ...
; loading /home/ckellerm/chickens/master/lib/chicken/7/advice.import.so ...
; loading /home/ckellerm/chickens/master/lib/chicken/7/trace.so ...
; loading /home/ckellerm/chickens/master/lib/chicken/7/advice.so ...
#;2> (trace load-from-file)
; tracing load-from-file
#;3> (bf-eval (load-from-file "hello.bf"))
[0] (load-from-file "hello.bf")
[0] load-from-file -> #,<vm pc 0 data 0 (0) stack ()> 
Hello World!
\end{verbatim}

\newthought{So first we} load the brainfuck source code with the {\tt
  ,l} top-level command, then load the trace extension. This will get
us the {\tt trace} procedure which will tell us when a certain
procedure gets called and what its return value is. In this case I
have choosen the {\tt load-from-file} procedure because it get's
called only once. Try to trace other procedures in this interpreter,
you will notice that they get called a lot. What you may notice is the
number in squared brackets. This will show you the nesting level you
are looking at. When you try it on the {\tt bf-eval} procedure you
will see that it gets called hundreds of times (depending on the
number of input characters of course). This may also help you when
trying to get an idea of what's going on inside your program.

\newthought{Once you are} done tracing a procedure, you can remove the
tracing point by issuing the {\tt untrace} command.
\begin{verbatim}
#;4> (untrace load-from-file)
; untracing f_642
\end{verbatim}
\marginnote{The {\tt f\_642} procedure name is chicken's internal idea
  of that the tracing procedure is actually called. What happens
  behind the scene is that your procedure gets wrapped in another
  procedure and gets assigned the original name. Upon untracing the
  original name binding is restored again.}

\newthought{Besides tracing} there are other useful debugging commands
provided by the trace extension. Instead of printing out the arguments
and return values you might want to stop the execution of your program
at a certain point. This is called a ``breakpoint'' in debuggers and
the trace extension provides a {\tt break} procedure that will wrap
your procedure like {\tt trace} but will signal an exception which
will stop the execution.
\begin{verbatim}
#;5> (break move-left)
; setting break-point in move-left
#;6> (bf-eval (load-from-file "hello.bf"))

Error: (move-left) *** breakpoint ***: (move-left #,<vm pc 319 data 4 (1) stack (59)>)

	Call history:

	<eval>	  (vm-pc v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 2)
	<eval>	  (vm-idx v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 1)
	<eval>	  (u8vector-ref (vm-tape v) (vm-idx v))
	<eval>	  (vm-tape v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 5)
	<eval>	  (vm-idx v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 1)
	<eval>	  (vm-paren-stack v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 4)	<--
\end{verbatim}
\newthought{Now the program} has been stopped by the exception. You
can now inspect local variables and the call frame by the {\tt ,c}
top-level command. Once you are done with that. you can resume
execution by calling the {\tt continue} procedure.
\begin{verbatim}
#;6> (continue)

Error: (move-left) *** breakpoint ***: (move-left #,<vm pc 320 data 3 (3) stack (59)>)

	Call history:

	<eval>	  (vm-pc v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 2)
	<eval>	  (vm-idx v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 1)
	<eval>	  (u8vector-ref (vm-tape v) (vm-idx v))
	<eval>	  (vm-tape v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 5)
	<eval>	  (vm-idx v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 1)
	<eval>	  (vm-paren-stack v)
	<eval>	  (##sys#check-structure x (##core#quote vm))
	<eval>	  (##sys#block-ref x 4)	<--
#;6> (unbreak move-left)
; removing break-point in f_642
\end{verbatim}
\newthought{What happened?} Oh right, we have encountered another
breakpoint. Delete breakpoints by calling the {\tt unbreak} procedure.
After that the {\tt (continue)} procedure will run the program until
the end.

\newthought{As you may} have noticed the trace extension only works on
this procedure call level. Until now there is no easier way to step
single statements in CHICKEN Scheme like in other programming
languages. The trace egg may serve as a base for such an
implementation. It surely can help you to find the region of interest
in your program.

\newthought{In this chapter} you have seen a small interpreter written
in CHICKEN Scheme and also how to run it in the interpreter {\tt
  csi}. Furthermore you now know a little helper to debug your own
code more efficiently. You may want to play a bit with the interpreter
itself or the tracing tools mentioned here. How about introducing
little changes and try to find them with the trace extension?

\newthought{The whole documentation} of the trace extension can be
found on its wiki or chicken-doc page.


\chapter{Make CHICKEN move these boxes - A little game of sokoban}
\label{ch:sokoban}

\newthought{The last chapter} may have been playful, the following
will be even more so. As we deepen our knowledge of the CHICKEN
toolchain we will implement a simple puzzle game called sokoban.

\newthought{In this game} you are a worker in a peculiar storage left
alone with a couple of boxes that need to be put in their place. But
as these boxes are really heavy, all you can do to them is push them
hard in the right direction. As if this setting is not surreal enough
already, the architect of your working place must have been a little
nuthead as each level of your store house is build like a labyrinth
where there is only one way to move the boxes to the correct location.

\newthought{So to sum up} the rules, they are (according to wikipedia):

\begin{itemize} % TODO Add rules for sokoban
\item Rule 1
\item Rule 2
\item Rule 3
\item Rule 4
\end{itemize}

\newthought{The game will} start out with presenting a top down view
of the storage building, with walls marked as a {\em '\#'} (hash mark),
Free floor space will be noted as a space character {\em ' '}, the
box-pusher will be depicted as an {\em '@'} sign, your boxes look like
{\em '\$'}s and the target spots will be presented with a {\em '.'}.

\newthought{After printing the map} the player will have to ponder her
next move and the game will accept movement commands of the
player. The poor box-pusher will move anywhere you tell him, provided
that there is a free spot. If you command the box-pusher to ``run
into'' a box, the box will get pushed instead into the direction, if
there is a free spot next to the box.

\newthought{After you told the box-pusher} where to go, the game will
see whether your command is a valid move within the rules of the game
stated above. If this is the case it carries out the movement and
presents you with an updated map of the storage building.

\newthought{This cycle or loop} will repeat until you move all the
boxes into a designated target spot, restart from the beginning (maybe
you pushed a box into a dead end), or call it quits with the game.

\newthought{So you need to think a lot}, but so does the program as
well! It needs to keep track of several things to be able to present
the map of the storage building, the box-pusher position, the position
of the boxes and the position of the target spots. All these things
the program needs to take care of is called {\em state}.

\newthought{How should the state be} accessed or passed around? This
is one of the fundamental design decisions that determine the
programming style of a program. One can change the state at will
throughout the different procedures that handle state by assigning or
{\em mutating} the old values to new ones. This is often called {\em
  imperative programming}. Another way could be to pass each procedure
the current state as a parameter and have the procedures return an
updated state when it is done (or passes through unchanged
states). This is called {\em functional programming}.

\newthought{With CHICKEN Scheme} you can have both worlds and use them
as it fits your problem at hand! Changing state is done with the {\em
  set!} procedure as you have seen already in the previous
chapter. For a functional programming style you can either pass each
state as a separate argument to your procedures or when you need to
pass around lots of state, choose a container holding on to your state
variables.

\newthought{One standard container} in CHICKEN Scheme is called a {\em
  record}. Records provide a container to a collection of things,
called {\em slots}. Each slot will have an accessor (or getter) and a
setter procedure defined. You can distinguish a record from other
scheme objects by asking its predicate. The magic to make all this
happen is a constructor called {\em define-record}.

\newthought{The game needs} to keep track of the current board, the
position of the player, the position of the boxes, and the position of
target spots. The positions will be written as list of pairs, to be
read as {\em '(X . Y) coordinate}. The board itself is a list of
strings, one string for each set of Y coordinates using the characters
from above. As a simple example of the little (and dead easy) map of

\begin{verbatim}
######
# @$.#
######
\end{verbatim}\marginnote{Our poor box-pusher is almost done here!}

Looks like the following when put into a game record. First we {\em
  construct} it with {\em make-record} then ask a game about its
slots. the setter {\em game-player-set!} allows you to change a single
slot in an object should you need it.

% XXX TODO Add a csi session here with these commands to show how
% records are printed
\begin{lstlisting}[caption=Using record types in CHICKEN]
(define-record game board player boxes spots)

(define g (make-game '("######" "# @$.#" "######") '(2 . 1) '((3 . 1)) '((4 . 1))))

(game? g) ;;* $\rightarrow$ \#t *;;

(game-board g) ;;* $\rightarrow$ '("\#\#\#\#\#\#" "\# @\$.\#" "\#\#\#\#\#\#") *;;

(game-player-set! g '(3 . 1))

(game-player g) ;;* $\rightarrow$ (3 . 1)*;;
\end{lstlisting}
%$ appease syntax highlighting
\newthought{Scheme records allow mutation} so it is up to the
programmer whether to use a record in a functional or imperative
style. The procedures of the sokoban game will return new copies of
the game state record so they are {\em functional}.

\newthought{As the board} consists of a list of strings, helper
procedures to get a tile from a coordinate, change the tile at a
coordinate make the code mode readable elsewhere by hiding all the
referencing logic in one place. One possible random access list
procedure {\em list-ref} has been choosen from an extension to the
R5RS scheme standard, {\em srfi-1}, which is shipped with the CHICKEN
scheme core.

\newthought{SRFI-1 stands for:} Schemer's Request For Implementation
Number 1. A lot of these extensions have been proposed over time (more
than one hundred!) but the first is one of the most widely implemented
ones amongst scheme implementations. To be able to use procedures from
srfi-1 in CHICKEN {\em (use srfi-1)}.

\newthought{Another convention that can} be observed is the usage of a
predicate to guard parameter values before computing a result. If it
is acceptable for a procedure to return a false value this method if
often more readable than rewriting it in an {\em if} clause. Compare
the following two variants:
%% XXX TODO put these two beside each other
\begin{lstlisting}[caption=get-tile with a guarding predicate]
;; Get a tile off the game board
(define (get-tile board x y)
   (and
    (<= 0 y)
    (<= 0 x)
    (< y (length board))
    (< x (length (list-ref board y)))
    (list-ref (list-ref board y) x)))
\end{lstlisting}
\begin{lstlisting}[caption=get-tile using an if clause]
;; Get a tile off the game board
(define (get-tile board x y)
  (if (and
       (<= 0 y)
       (<= 0 x)
       (< y (length board))
       (< x (length (list-ref board y))))
      (list-ref (list-ref board y) x)
      #f))
\end{lstlisting}
\newthought{Note} that this trick only works if your computation does
not return a false value as you would be unable to distinguish a {\em
  \#f} returned by your computation from a mismatched assertion about
a parameter (for example x or y being negative).

\newthought{In this case} however all will be fine as there will only
be values stored in our board that will evaluate to \#t (as everything
other than \#f does in scheme). And {\em list-ref} will return
something meaningful because our assertions have all been met and the
coordinate values are reasonable.

% -----------------------------------------------------------------------
\end{document}

